<?
/*****************************************************************************/
/* PackageGet.php                                                            */
/*****************************************************************************/
/* YaBB SE: Yet another Bulletin Board Splinter Edition                      */
/* Open-Source Project inspired by Zef Hemel (zef@zefhemel.com)              */
/* Software Version:           YaBB SE 1.5.1                                 */
/* Software by:                The YaBB SE Development Team                  */
/* ========================================================================= */
/* Software Distributed by:    http://www.yabbse.org                         */
/* Copyright 2001-2003 by:     http://www.lewismedia.com (Lewis Media)       */
/* Support, News, Updates at:  http://www.yabbse.org/community               */
/* Inspired and Ported From:   http://www.yabbforum.com                      */
/*****************************************************************************/
/* This program is free software; you may redistribute it and/or modify it   */
/* under the terms of the provided license as published by Lewis Media.      */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the provided    */
/* license for more information.                                             */
/*                                                                           */
/* See license.txt for details of the YaBB SE license. The latest version    */
/* of this license can be found at the distributor's site seen above.        */
/*****************************************************************************/

$packagegetphpver = 'YaBB SE 1.5.1';

$safe_mode = ini_get("safe_mode");

// verify the user is an administrator
is_admin();

function PackageGet()
{
	global $txt, $color, $scripturl, $yytitle, $override, $modSettings, $cgi, $mbname, $imagesdir;


	$displayLinkTree = ($modSettings['enableInlineLinks'] ? "<font size=\"1\" class=\"nav\"><b><a href=\"$scripturl\" class=\"nav\">$mbname</a> </b>&nbsp;|&nbsp;<b> " : "<font size=\"2\" class=\"nav\"><b><img src=\"$imagesdir/open.gif\" border=\"0\" alt=\"\" />&nbsp;&nbsp;<a href=\"$scripturl\" class=\"nav\">$mbname</a><br />");
	$displayLinkTree .= ($modSettings['enableInlineLinks'] ? "<a href=\"$cgi;action=packages\" class=\"nav\">$txt[package1]</a> </b>&nbsp;|&nbsp;<b> " : "<img src=\"$imagesdir/tline.gif\" border=\"0\" alt=\"\" /><img src=\"$imagesdir/open.gif\" border=\"0\" alt=\"\" />&nbsp;&nbsp;<a href=\"$cgi;action=packages\" class=\"nav\">$txt[package1]</a><br />");
	$displayLinkTree .= ($modSettings['enableInlineLinks'] ? "<a href=\"$cgi;action=packageget\" class=\"nav\">$txt[yse183]</a> </b></font>" : "<img src=\"$imagesdir/tline2.gif\" border=\"0\" alt=\"\" /><img src=\"$imagesdir/open.gif\" border=\"0\" alt=\"\" />&nbsp;&nbsp;<a href=\"$cgi;action=packageget\" class=\"nav\">$txt[yse183]</a></font><br />");
	$yytitle = "$mbname - $txt[package1] - $txt[yse182]";
	template_header();
	echo '
		<table width="100%" align="center"><tr><td valign="bottom">' . $displayLinkTree . '</td></tr></table>
		<table border="0" width="100%" cellspacing="0" cellpadding="0" class="bordercolor">
			<tr>
				<td>
					<table border="0" width="100%" cellspacing="1" cellpadding="4" class="bordercolor">
						<tr>
							<td class="titlebg" align="center" colspan="2"><b>' . $mbname . ' - ' . $txt['package1'] . ' - ' . $txt['yse183'] . '</b></td>
						</tr><tr>
							<td class="catbg" colspan="2"><b>' . $txt['yse183'] . '</b></td>
						</tr><tr>
							<td class="windowbg" width="20" valign="middle" align="center"><img src="' . $imagesdir . '/boardmod_main.gif" border="0" width="20" height="20" alt="" /></td>
							<td class="windowbg2">
								<table border="0" cellpadding="1" cellspacing="0" width="100%">';
	$servers = file("Packages/server.list");
	for ($i=0 ; $i<count($servers) ; ++$i)
	{
		list($name, $url) = explode("|^|", $servers[$i]);
		$name = stripslashes($name);
		echo '<tr><td>' . $name . '</td><td><a href="' . $scripturl . '?action=pgbrowse;server=' . $i . '">[ ' . $txt['yse184'] . ' ]</a></td><td><a href="' . $scripturl . '?action=pgremove;server=' . $i . '">[ ' . $txt['yse138'] . ' ]</a></td></tr>';
	}
	echo '
								</table>
							</td>
						</tr><tr>
							<td class="catbg" colspan="2"><b>' . $txt['yse185'] . '</b></td>
						</tr><tr>
							<td class="windowbg" width="20" valign="middle" align="center"><img src="' . $imagesdir . '/boardmod_main.gif" border="0" width="20" height="20" alt="" /></td>
							<td class="windowbg2">
								<form action="' . $scripturl . '?action=pgadd" method="post">
									<table border="0" cellspacing="0" cellpadding="4">
										<tr>
											<td valign="top"><b>' . $txt['yse186'] . ':</b></td>
											<td valign="top"><input type="text" name="name" size="40" value="YaBB SE" /></td>
										</tr><tr>
											<td valign="top"><b>' . $txt['yse187'] . ':</b></td>
											<td valign="top"><input type="text" name="serverurl" size="50" value="http://" /></td>
										</tr><tr>
											<td colspan="2"><input type="submit" value="' . $txt['yse185'] . '" /></td>
										</tr>
									</table>
								</form>
							</td>
						</tr>
						</tr><tr>
							<td class="catbg" colspan="2"><b>' . $txt['package2'] . '</b></td>
						</tr><tr>
							<td class="windowbg" width="20" valign="middle" align="center"><img src="' . $imagesdir . '/boardmod_main.gif" border="0" width="20" height="20" alt="" /></td>
							<td class="windowbg2">
								<a href="' . $scripturl . '?action=packagebrowse">[ ' . $txt['package3'] . ' ]</a><br />
								<a href="' . $scripturl . '?action=packagecreate">[ ' . $txt['package4'] . ' ]</a><br />
								<a href="' . $scripturl . '?action=packageget">[ ' . $txt['package5'] . ' ]</a><br />
								<a href="' . $scripturl . '?action=pkinstalllist">[ ' . $txt['package6'] . ' ]</a><br />
							</td>
						</tr>
					</table>
				</td>
			</tr>
		</table>';
	footer();
	obExit();
}

function PackageServerAdd()
{
	global $name, $serverurl;
	$fp = fopen("Packages/server.list", "a");
	fputs($fp, "$name|^|$serverurl\n");
	fclose($fp);
	header("Location: $scripturl?action=packageget");
}

function PackageServerRemove()
{
	global $server;
	$servers = file("Packages/server.list");
	$fp = fopen("Packages/server.list", "w");
	for ($i=0 ; $i<count($servers) ; ++$i)
		if ($i != $server)
			fputs($fp, chop($servers[$i])."\n");
	header("Location: $scripturl?action=packageget");
}

function PackageBrowse()
{
	global $server, $yytitle, $txt, $safe_mode, $boardurl;

	$servers = file("Packages/server.list");
	list($name, $url) = explode("|^|", $servers[$server]);
	$url = chop($url);
	$packages = array();
	if ($safe_mode)
	{
		header("Location: $url/index.php?ref=$boardurl");
		obExit();
	}
	$rf = fopen($url."/package.list", "r") or die("Could not connect to server");
	while (!feof($rf))
		$packages[] = fgets($rf, 4096);
	fclose($rf);

	if (count($packages) == 0)
		die("An error occured, could not connect or packages.list does not exist");

	$yytitle = $txt['yse183'] . ' - ' . $name;
	template_header();
	echo '
		<table border="0" cellpadding="0" cellspacing="6" align="center" width="100%">
			<tr>
				<td colspan="2" width="100%">
					<table border="0" cellpadding="5" cellspacing="1" align="center" bgcolor="' . $color['bordercolor'] . '" class="bordercolor" width="100%">
						<tr>
							<td bgcolor="' . $color['titlebg'] . '" class="titlebg" height="23" align="center" colspan="2"><font size="4" color="' . $color['titletext'] . '">' . $txt['yse183'] . ' - ' . $name . '</font></td>
						</tr><tr>
							<td class="windowbg" bgcolor="' . $color['windowbg'] . '" valign="middle" align="left" width="100%">';
	if (count($packages) == 1 && !chop($packages[0]))
		echo "<li>$txt[yse189]";
	else
	{
		$j = 1;
		for ($i=0 ; $i<count($packages) ; ++$i)
		{
			list($name, $filename, $desc, $version, $author, $authoremail, $authorhompage) = explode("|^|", $packages[$i]);
			if (chop($desc) == "")
				$desc = $txt['pacman8'];
			if ($name == '-')
				echo "<hr width=\"75%\" align=\"left\" />";
			else if (chop($filename) == 'head')
			{
				echo "<b><font size=\"+1\">$name</font></b><br />";
				$j = 1;
			}
			else if (chop($filename) == 'text')
			{
				echo "$name<br />";
				$j = 1;
			}
			else
			{
				echo '<br />' . $j . '. <b>' . $name . '</b> <a href="' . $scripturl . '?action=pgdownload;server=' . $server . ';package=' . $filename . '">[ ' . $txt['yse190'] . ' ]</a>';
				if (chop($version))
					echo '<br />' . $txt['pacman3'] . ':&nbsp; ' . $version;
				if (chop($author))
					echo '<br />' . $txt['pacman4'] . ':&nbsp; ' . $author;
				if (chop($authoremail))
					echo '<br />' . $txt['pacman5'] . ':&nbsp; ' . $authoremail;
				if (chop($authorhompage))
				{
					$pos = strpos(strtolower($authorhompage), "a href");
					if ($pos === false)
					{
						echo '<br />' . $txt['pacman6'] . ':&nbsp; <a href="' . $authorhompage . '">';
						if (chop($author))
							echo chop($author);
						else
							echo $txt['pacman6'];
						echo '</a>';
					}
					else
						echo '<br />' . $txt['pacman6'] . ':&nbsp; ' . $authorhompage;
				}
				echo '<br />' . $txt['pacman9'] . ':&nbsp; ' . $desc . '
					<br />' . $txt['pacman10'] . ':&nbsp; <a href="' . $url . '/' . $filename . '">' . $url . '/' . $filename . '</a><br />';
				$j++;
			}
		}
	}
	echo '
								<br /><br /><a href="' . $scripturl . '?action=packageget">[ ' . $txt[193] . ' ]</a>
							</td>
						</tr>
					</table>
				</td>
			</tr>
		</table>';
	footer();
	obExit();
}


function PackageDownload()
{
	global $server, $package, $yytitle, $txt;

	$servers = file("Packages/server.list");
	list($name, $url) = explode("|^|", $servers[$server]);
	$url = chop($url);
	$rf = fopen($url . "/" . $package, "rb") or die($txt['yse191']);
	$buffer = "";
	while (!feof($rf))
		$buffer .= fread($rf, 1024);
	fclose($rf);

	$fp = fopen("Packages/$package", "wb");
	fputs($fp, $buffer);
	fclose($fp);

	$yytitle = $txt['yse192'];
	template_header();
	echo '
		<table border="0" cellpadding="0" cellspacing="6" align="center" width="100%">
			<tr>
				<td colspan="2" width="100%">
					<table border="0" cellpadding="5" cellspacing="1" align="center" bgcolor="' . $color['bordercolor'] . '" class="bordercolor" width="100%">
						<tr>
							<td bgcolor="' . $color['titlebg'] . '" class="titlebg" height="23" align="center" colspan="2">
								<font size="4" color="' . $color['titletext'] . '">' . $txt['yse192'] . '</font>
							</td>
						</tr><tr>
							<td class="windowbg" bgcolor="' . $color['windowbg'] . '" valign="middle" align="left" width="100%">
								' . $txt['yse193'] . '<br /><br />
								<a href="' . $scripturl . '?action=pgbrowse;server=' . $server . '">[ ' . $txt[193] . ' ]</a>
							</td>
						</tr>
					</table>
				</td>
			</tr>
		</table>';
	footer();
	obExit();
}

?>