<?php
/*****************************************************************************/
/* RemoveOldThreads.php                                                      */
/*****************************************************************************/
/* YaBB SE: Yet another Bulletin Board Splinter Edition                      */
/* Open-Source Project inspired by Zef Hemel (zef@zefhemel.com)              */
/* Software Version:           YaBB SE 1.5.1                                 */
/* Software by:                The YaBB SE Development Team                  */
/* ========================================================================= */
/* Software Distributed by:    http://www.yabbse.org                         */
/* Copyright 2001-2003 by:     http://www.lewismedia.com (Lewis Media)       */
/* Support, News, Updates at:  http://www.yabbse.org/community               */
/* Inspired and Ported From:   http://www.yabbforum.com                      */
/*****************************************************************************/
/* This program is free software; you may redistribute it and/or modify it   */
/* under the terms of the provided license as published by Lewis Media.      */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the provided    */
/* license for more information.                                             */
/*                                                                           */
/* See license.txt for details of the YaBB SE license. The latest version    */
/* of this license can be found at the distributor's site seen above.        */
/*****************************************************************************/

$removeoldthreadsphpver = 'YaBB SE 1.5.1';

function RemoveOldThreads()
{
	global $yytitle, $settings, $txt, $db_prefix, $modSettings, $maxdays, $sc;
	if ($settings[7] != "Administrator")
		fatal_error($txt[1]);

	$yytitle = "$txt[120] $maxdays";
	template_header();

	echo '
		<table width="450" cellspacing="0" cellpadding="0" align="center" bgcolor="#FFFFFF">
			<tr> 
				<td width="100%" valign="top">
					<table width="100%" border="0" cellspacing="1" bgcolor="#6394BD" class="bordercolor">
						<tr>
							<td bgcolor="#6E94B7" class="titlebg"><font size="2" color="#FFFFFF" class="text1"><b>' . $txt[120] . ' ' . $maxdays . '</b></font></td>
						</tr><tr>
							<td align="center" bgcolor="#AFC6DB" class="windowbg"><br />
								<form action="?action=removeoldthreads2" method="post">
									<font size="2">' . $txt[124] . ' <input type="text" name="maxdays" value="' . $maxdays . '" size="2" /> ' . $txt[579] . '
									<input type="submit" value="' . $txt[31] . '" /></font>
									<br /><br /><b><a href="?action=admin">' . $txt[193] . '</a></b>
									<input type="hidden" name="sc" value="' . $sc . '" />
								</form>
							</td>
						</tr>
					</table>
				</td>
			</tr>
		</table>';

	footer();
	obExit();
}

function RemoveOldThreads2()
{
	global $yytitle, $settings, $txt, $db_prefix, $modSettings, $maxdays;

	checkSession();
	if ($settings[7] != "Administrator")
		fatal_error($txt[1]);

	$yytitle = "$txt[120] $maxdays";
	$threshold = time()-(24*60*60*$maxdays);
	template_header();
	$request = mysql_query("SELECT t.ID_TOPIC, t.ID_BOARD, t.ID_POLL FROM {$db_prefix}topics AS t, {$db_prefix}messages AS m WHERE (m.ID_MSG = t.ID_LAST_MSG AND m.posterTime < $threshold);") or database_error(__FILE__, __LINE__);
	while ($row = mysql_fetch_row($request))
	{
		$msgs = 0;
		echo "$txt[50] - $row[0]<br />\n";
		echo "&nbsp;&nbsp;$txt[49]<br />\n";
	//Lines 81-86 all there to delete attachments on thread deletion - Jeff
		$result = mysql_query("SELECT attachmentFilename FROM {$db_prefix}messages WHERE ID_TOPIC=$row[0] AND (attachmentFilename IS NOT NULL);") or database_error(__FILE__, __LINE__);
		if (mysql_num_rows($result) > 0)
			while ($attachRow = mysql_fetch_array($result))
				unlink($modSettings['attachmentUploadDir'] . "/" . $attachRow['attachmentFilename']);
		$result = mysql_query ("DELETE FROM {$db_prefix}messages WHERE ID_TOPIC='$row[0]';") or database_error(__FILE__, __LINE__);
		$msgs = mysql_affected_rows();
		$result = mysql_query("DELETE FROM {$db_prefix}polls WHERE ID_POLL='$row[2]' LIMIT 1;") or database_error(__FILE__, __LINE__);
		$result = mysql_query ("DELETE FROM {$db_prefix}topics WHERE ID_TOPIC='$row[0]';") or database_error(__FILE__, __LINE__);
		$result = mysql_query("DELETE FROM {$db_prefix}log_topics WHERE ID_TOPIC='$row[0]'") or database_error(__FILE__, __LINE__);
		$result = mysql_query ("DELETE FROM {$db_prefix}calendar WHERE ID_TOPIC='$row[0]'") or database_error(__FILE__, __LINE__);
		$result = mysql_query ("UPDATE {$db_prefix}boards SET numTopics=numTopics-1, numPosts=numPosts-$msgs WHERE ID_BOARD=$row[1];") or database_error(__FILE__, __LINE__);

		updateStats('message');
		updateStats('topic');
		updateLastMessage($row[1]);
	}
	echo " <br />$txt[51]<br /> <br />";
	footer();
	obExit();
}

?>